import * as ts from "typescript";
import { Example, JsDocGenerator, ModulePathMapper } from "./JsDocGenerator";
import { Class, Descriptor, MethodDescriptor, Variable } from "./psi";
export declare class JsDocRenderer {
    private readonly generator;
    indent: string;
    constructor(generator: JsDocGenerator);
    normalizeDescription(comment: string): string;
    normalizeDescription2(comment: string): string;
    formatComment(node: ts.Node, tags: Array<string>, description?: string): string;
    renderClassOrInterface(descriptor: Class, modulePathMapper: ModulePathMapper, examples?: Array<Example>): string;
    renderMethod(method: MethodDescriptor, modulePathMapper: ModulePathMapper, classDescriptor: Class | null): string;
    static getComment(node: ts.Node): string | null;
    renderVariable(descriptor: Variable, modulePathMapper: ModulePathMapper): string;
    renderMember(descriptor: Descriptor): string;
    private static renderProperties(properties, tags, modulePathMapper);
}
