"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.generateAndWrite = undefined;

var _bluebirdLst;

function _load_bluebirdLst() {
    return _bluebirdLst = require("bluebird-lst");
}

var _bluebirdLst2;

function _load_bluebirdLst2() {
    return _bluebirdLst2 = _interopRequireDefault(require("bluebird-lst"));
}

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

let generateAndWrite = exports.generateAndWrite = (() => {
    var _ref3 = (0, (_bluebirdLst || _load_bluebirdLst()).coroutine)(function* (basePath, config, tsConfig) {
        let packageData = { name: "packageJsonNotDefined" };
        try {
            packageData = yield (0, (_fsExtraP || _load_fsExtraP()).readJson)(_path.join(basePath, "package.json"));
        } catch (e) {}
        const options = typeof tsConfig.jsdoc === "string" ? { out: tsConfig.jsdoc } : tsConfig.jsdoc;
        if (options.out == null) {
            throw new Error("Please specify out in the tsConfig.jsdoc (https://github.com/develar/ts2jsdoc#generate-jsdoc-from-typescript)");
        }
        const generator = (0, (_JsDocGenerator || _load_JsDocGenerator()).generate)(basePath, config, packageData.name, packageData == null ? null : packageData.main, options);
        const out = _path.resolve(basePath, options.out);
        console.log(`Generating JSDoc to ${out}`);
        yield (0, (_fsExtraP || _load_fsExtraP()).emptyDir)(out);
        const oldModulePathToNew = computeModuleNameMappings(generator);
        const exampleDir = options.examples == null ? null : _path.resolve(basePath, options.examples);
        const existingClassExampleDirs = exampleDir == null ? null : new Set((yield (0, (_fsExtraP || _load_fsExtraP()).readdir)(exampleDir)).filter(function (it) {
            return it[0] != "." && !(it.indexOf(".") !== -1);
        }));
        for (const _ref4 of generator.moduleNameToResult.entries()) {
            var _ref5 = _slicedToArray(_ref4, 2);

            const moduleId = _ref5[0];
            const psi = _ref5[1];

            const modulePathMapper = function (oldPath) {
                if (!oldPath.startsWith("module:")) {
                    return oldPath;
                }
                const result = oldModulePathToNew.get(oldPath);
                if (result != null) {
                    return result;
                }
                if (moduleId === generator.moduleName && options.externalIfNotMain != null) {
                    // external:electron-builder/out/platformPackager.PlatformPackager is not rendered by jsdoc2md,
                    // only PlatformPackager
                    const dotIndex = oldPath.lastIndexOf(".");
                    const value = oldPath.substring(dotIndex + 1);
                    externalToModuleName.set(value, oldPath.substring(oldPath.indexOf(":") + 1, dotIndex));
                    return `external:${value}`;
                }
                return oldPath;
            };
            let result = "";
            const externalToModuleName = new Map();
            for (const d of copyAndSort(psi.members)) {
                if (d.kind == null) {
                    result += generator.renderer.renderVariable(d, modulePathMapper);
                } else {
                    result += generator.renderer.renderMember(d);
                }
            }
            for (const d of copyAndSort(psi.classes)) {
                let examples = [];
                if (existingClassExampleDirs != null && existingClassExampleDirs.has(d.name)) {
                    const dir = _path.join(exampleDir, d.name);
                    examples = yield (_bluebirdLst2 || _load_bluebirdLst2()).default.map((yield (0, (_fsExtraP || _load_fsExtraP()).readdir)(dir)).filter(function (it) {
                        return it[0] != "." && it.indexOf(".") !== -1;
                    }), (() => {
                        var _ref6 = (0, (_bluebirdLst || _load_bluebirdLst()).coroutine)(function* (it) {
                            const ext = _path.extname(it);
                            return {
                                name: _path.basename(it, ext),
                                content: yield (0, (_fsExtraP || _load_fsExtraP()).readFile)(_path.join(dir, it), "utf8"),
                                lang: ext
                            };
                        });

                        return function (_x5) {
                            return _ref6.apply(this, arguments);
                        };
                    })());
                }
                result += generator.renderer.renderClassOrInterface(d, modulePathMapper, examples);
            }
            for (const d of copyAndSort(psi.functions)) {
                result += generator.renderer.renderMethod(d, modulePathMapper, null);
            }
            if (result === "") {
                continue;
            }
            let externalJsDoc = "";
            for (const _ref7 of externalToModuleName) {
                var _ref8 = _slicedToArray(_ref7, 2);

                const external = _ref8[0];
                const moduleId = _ref8[1];

                externalJsDoc += `/**\n* @external ${external}\n* @see ${options.externalIfNotMain}#module_${moduleId}.${external}\n*/\n`;
            }
            yield (0, (_fsExtraP || _load_fsExtraP()).writeFile)(_path.join(out, moduleId.replace(/\//g, "-") + ".js"), `${externalJsDoc}/** 
 * @module ${moduleId}
 */

${result}`);
        }
    });

    return function generateAndWrite(_x2, _x3, _x4) {
        return _ref3.apply(this, arguments);
    };
})();

var _path = _interopRequireWildcard(require("path"));

var _fsExtraP;

function _load_fsExtraP() {
    return _fsExtraP = require("fs-extra-p");
}

var _JsDocGenerator;

function _load_JsDocGenerator() {
    return _JsDocGenerator = require("./JsDocGenerator");
}

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function computeModuleNameMappings(generator) {
    const mainModuleName = generator.moduleName;
    const mainPsi = generator.moduleNameToResult.get(mainModuleName);
    const oldModulePathToNew = new Map();
    for (const _ref of generator.mainMappings) {
        var _ref2 = _slicedToArray(_ref, 2);

        const id = _ref2[0];
        const names = _ref2[1];

        const psi = generator.moduleNameToResult.get(id);
        for (const name of names) {
            if (moveMember(psi.classes, mainPsi.classes, name, mainModuleName)) {
                oldModulePathToNew.set(`module:${id}.${name}`, `module:${mainModuleName}.${name}`);
                continue;
            }
            moveMember(psi.functions, mainPsi.functions, name) || moveMember(psi.members, mainPsi.members, name);
        }
    }
    return oldModulePathToNew;
}
function moveMember(members, mainPsiMembers, name) {
    let newId = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;

    const index = members.findIndex(it => it.name === name);
    if (index < 0) {
        return false;
    }
    const member = members[index];
    if (newId != null) {
        member.modulePath = "module:" + newId;
    }
    mainPsiMembers.push(member);
    members.splice(index, 1);
    return true;
}

function copyAndSort(members) {
    return members.slice().sort((a, b) => a.name.localeCompare(b.name));
}
//# sourceMappingURL=manager.js.map